-------------------------------------------------------------------

     =========================================================
     Geant4 - an Object-Oriented Toolkit for Simulation in HEP
     =========================================================

                  Hadronic physics-list/lists History
                  -----------------------------
This file should be used  to briefly summarize all major modifications
introduced in the code and keeptrack of all tags.

     ----------------------------------------------------------
     * Reverse chronological order (last date on top), please *
     ----------------------------------------------------------

25-October-2021 B.Morgan (phys-lists-V10-07-10)
- Use G4StrUtil functions replacing deprecated G4String member functions

25-August-2021 Dennis Wright (phys-lists-V10-07-09)
- LBE.cc: replace G4RadioactiveDecayBase with G4RadioactiveDecay
  see top level History file
 
28-April-2021 R. Hatcher (phys-lists-V10-07-08)
- corresponding changes to G4PhysListFactoryAlt ctor to maintain drop-in
  compatibility with older factory.

24-April-2021 V.Ivanchenko  (phys-lists-V10-07-07)
- in all Physics List protect banners by verbosity level
- G4PhysListFactory add verbosity level to constructor and 
  propagate to constructed Physics List

16-April-2021 Ben Morgan (phys-lists-V10-07-06)
- Migrate build to modular CMake API

13-April-2021  Alberto Ribon (phys-lists-V10-07-05)
-  GNUmakefile, sources.cmake : removed dependency on hadronic/model/util
   and hadronic/model/management (that have been now deleted, with their
   classes moved to hadronic/util and hadronic/management).

18-March-2021  Alberto Ribon (phys-lists-V10-07-04)
 - LBE.cc : renamed G4HadronCaptureProcess as G4NeutronCaptureProcess.

04-March-2021  Alberto Ribon (phys-lists-V10-07-03)
 - LBE.cc : replaced particle-specific hadronic inelastic processes
   (that have been deleted) with G4HadronInelasticProcess.

24-February-2021 Daren Sawkey (phys-lists-V10-07-02)
 - LBE.cc. Remove deprecated optical commands.

17-February-2021  Robert Hatcher (phys-lists-V10-07-01)
 - Update list of EM extension shorthands known to extensible factory to
   match old factory

24-November-2020  Alberto Ribon (phys-lists-V10-06-02)
 - LBE : added G4ShortLivedConstructor (to avoid crashes, e.g. when rho0
   is produced by the decay of eta_prime).

30-April-2020 Ben Morgan       (phys-lists-V10-06-01)
 - Remove obsolete GRANULAR_DEPENDENCIES entries

15-January-2020  Alberto Ribon (phys-lists-V10-06-00)
 - LBE : updated cross sections to avoid crashes caused by the removal of
   default Gheisha cross sections, and to have consistency between elastic
   and inelastic cross sections.

22-October-2019  Alberto Ribon (phys-lists-V10-05-04)
 - FTFP_BERT_HP, QGSP_BERT_HP, INCLXXPhysicsListHelper : added (consistently)
   RadioactiveDecay to all physics lists which use NeutronHP (the rationale
   is that precision is more valuable than speed for these physics lists;
   note that, among the reference physics lists with NeutronHP, only
   FTFP_BERT_HP, QGSP_BERT_HP, FTFP_INCLXX_HP and QGSP_INCLXX_HP did not have
   RadioactiveDecay activated by default).

06-August-2019  Alberto Ribon (phys-lists-V10-05-03)
 - FTF_BIC, QGS_BIC : use the newly introduced stopping physics constructor
   G4StoppingPhysicsFritiofWithBinaryCascade (instead of the default
   G4StoppingPhysics).
 - Shielding : replacing explicit values for the energy transition region
               with values from G4HadronicParameters.

31-July-2019  Gunter Folger (phys-lists-V10-05-02)
 - Code clean-up
   - remove template mechanism
      - except for G4GenericPhysicsList, G4PhysListStamper,
        and INCLXXPhysicsListHelper
   - delete copy ctor and assigmnet operator
   - for empty dtor, use =default
   - move include/x.icc to src/x.cc for lists without template
   - remove SetCuts() implementation where not specialised
   - remove version number from lists
   - remove G4DataQuestionaire


25-June-2019  Dennis Wright (phys-lists-V10-05-01)
- replace G4RadioactiveDecay with G4RadioactiveDecayBase in LBE.icc

18-March-2019 V.Ivanchenko  (phys-lists-V10-05-00)
- Shielding, QGSP_BIC_HP, QGSP_BIC_AllHP - cut for proton is set
    to zero (problem #2150) and code clean-up

21-November-2018 A. Ribon  (phys-lists-V10-04-07)
- Shielding : replaced "putenv" of the environmental variable
    G4NEUTRONHP_PRODUCE_FISSION_FRAGMENTS with a call to
    G4ParticleHPManager::SetProduceFissionFragments .

03-November-2018 V.Ivanchenko  (phys-lists-V10-04-06)
- PhysListFactory - added extra EM options "WVI" and "_EM"

15-October-2018 V.Ivanchenko  (phys-lists-V10-04-05)
- QGSP_BIC, Shielding, QBBC - return to use of EM physics Opt0
- QGSP_BIC_HP and QGSP_BIC_AllHP use EM Opt4
- Shielding, ShieldingLEND, QGSP_BIC, QGSP_BIC_HP, QGSP_BIC_AllHP
    implementation is moved to src, templated are removed

11-October-2018 R. Hatcher (phys-list-V10-04-04)
- Add "EM0" option to g4alt::G4PhysListFactory (via G4PhysListRegistry)

22-August-2018 V.Ivanchenko  (phys-lists-V10-04-03)
- QGSP_BIC_HP, Shielding, QBBC - use EM physics Opt4
- PhysListFactory - added extra EM option "EM0", which means the
   default Opt0 EM physics configuration

17-August-2018 V.Ivanchenko  (phys-lists-V10-04-02)
- QBBC - use G4IonPhysicsXS

06-August-2018 A. Ribon  (phys-list-V10-04-01)
- LBE : replaced the explicit high-energy limit of hadronic physics
  with the one from G4HadronicParameters .

26-Februrary-2018 R. Hatcher (phys-list-V10-04-00)
- cowork with phys-ctor-fact-V10-04-00
- Use new G4RegisterPhysicsConstructors.icc to ensure that for static builds
  G4PhysicsConstructorRegistry is populated.
- No longer register ShieldingLEND as a wrapper, but use explicit one

07-November-2017 T. Koi (phys-list-V10-03-08)
- Add ShieldingLEND as a new physics list
  co-working with phys-ctor-hinelastic-V10-03-06

07-November-2017 V.Ivanchenko  (phys-lists-V10-03-07)
- G4PhysListFactory - added messenger with two commands to enable
    radioactive decay or optical physics

02-November-2017 R. Hatcher (phys-list-V10-03-06)
- Add FTFQGSP_BERT to G4RegisterPhysLists.icc to make available to the
  new g4alt::G4PhysListFactory

16-October-2017 A.Ribon  (phys-lists-V10-03-05)
- FTFQGSP_BERT - created a new, experimental physics list which is similar
    to FTFP_BERT, but with QGS fragmentation of strings (instead of the
    Lund string fragmentation).

09-October-2017 V.Ivanchenko  (phys-lists-V10-03-04)
- LBE.icc - fixed initialisation of G4RadioactiveDecay

14-July-2017 Robert Hatcher               (phys-lists-V10-03-03)
- Add __SS option to g4alt::G4PhysListFactory
- allow g4alt factory to use bare phys constructor names as things to
    replace/add as well as the shorter predefined extensions (e.g. "EMX")
- whitespace cleanup

19-April-2017 V.Ivanchenko  (phys-lists-V10-03-02)
- G4PhysListFactory - fixed  EM option "__SS" - problem report #1966

21-March-2017 Koi, Tatsumi (phys-lists-V10-03-01)
- Fix problem of LBE physics list on radioactive decay model

07-February-2017 V.Ivanchenko  (phys-lists-V10-03-00)
- G4PhysListFactory - add single scattering EM option (required by
    several user groups), one need to add "__SS" to the reference
    physics list name

12-October-2016 G.Folger  (phys-lists-V10-02-10)
- remove direct use of theParticleIterator, get this from G4ParticleTable.
    fix required by clang39 on Windows and MAC

29-Sep-2016, Robert Hatcher               (phys-lists-V10-02-09)
- Reviewed changes in current context, propose w/ minimal changes

03-Jun-2016, Robert Hatcher               (phys-lists-V10-02-08)
- Require use of declaring and referencing macros to have
  a trailing semicolon; for case where macro expands to a
  namespace block, deal with eating up the ";"

26-May-2016, Robert Hatcher               (phys-lists-V10-02-07)
- Fix issue where G4PhysListRegistry didn't properly exit if
  a requested extension didn't exist in its list.
- Add G4_REFERENCE_PHYSLIST_FACTORY[_NS] for pulling in lists
  from static libraries.

26-May-2016, Alberto Ribon                (phys-lists-V10-02-06)
- QGSP_BIC_AllHP : use new, specialized ion constructor, G4IonPhysicsPHP.

10-May-2016, Robert Hatcher               (phys-lists-V10-02-05)
- mv src/G4RegisterPhysLists.cc to include/G4RegisterPhysLists.icc
  so that it gets compiled as part of the G4PhysListRegistry compilation
  unit.  This ensures that all the physics lists declared to the
  registry are referenced by it such that the linker will include
  them if libraries are built statically, even when the loader
  doesn't force whole-archive (not possible for MS Visual Studio) loading.
- Fix exception label so it is unique.

06-Apr-2016, Alberto Ribon                (phys-lists-V10-02-04)
- FTFP_BERT_ATL : created new, experimental physics list for ATLAS,
  similar to FTFP_BERT but with the transition between BERT and FTFP
  in the energy region [9, 12] GeV.

09-Mar-2016, Alberto Ribon                (phys-lists-V10-02-03)
- FTFP_BERT_TRV : Use GS multiple scattering with the most precise
  "error-free" stepping. This is done for the purpose of studying
  the impact of multiple scattering on hadronic showers.

23-Feb-2016, Alberto Ribon                (phys-lists-V10-02-02)
- FTFP_BERT_TRV : Use GS multiple scattering with the more precise option,
  (Opt3), instead of the default (Opt0). This is done for the purpose of
  studying the impact of multiple scattering on hadronic showers.

14-Jan-2016, Alberto Ribon                (phys-lists-V10-02-01)
- Re-submitting the previous tag (that was rejected).

04-Dec-2015, Alberto Ribon                (phys-lists-V10-02-00)
- FTFP_BERT_TRV : Switch on (again) the low-mass diffraction dissociation
  used in G4HadronHElasticPhysics

05-Nov-2015, Alberto Ribon                (phys-lists-V10-01-13)
- Removed neutron_hp/ .

04-Nov-2015, Robert Hatcher               (phys-lists-V10-01-12)
- Migrate responsibility for pulling the $PHYSLIST down to G4PhysListRegistry
  rather than the g4alt::G4PhysListFactory.
- Allow user to set a preferred default in case $PHYSLIST is not set;
  initial value (and value when set to "") is system default "FTFP_BERT".

03-Nov-2015, Alberto Ribon                (phys-lists-V10-01-11)
- LBE : Migrated to ParticleHP.

27-Oct-2015, Alberto Ribon                (phys-lists-V10-01-10)
- LBE : Replaced old G4GGNuclNuclCrossSection class with the new,
        recommended one, G4ComponentGGNuclNuclXsc .

01-Oct-2015, Robert Hatcher               (phys-lists-V10-01-09)
- g4alt::G4PhysListFactory - added extra EM option "_GS" and registered
    new QGSP_BIC_AllHP physics list to mirror original factory.

22-Sep-2015, Alberto Ribon              (phys-lists-V10-01-08)
- FTFP_BERT_TRV : Switch off (temporarily, for the release 10.2)
  the low-mass diffraction dissociation used in G4HadronHElasticPhysics

18-Sep-2015, V.Ivanchenko               (phys-lists-V10-01-07)
- G4PhysListFactory - added extra EM option "_GS" where
    G4GoudsmithSoundersonMscModel is used for e+-

10-Jun-2015, V.Ivanchenko               (phys-lists-V10-01-06)
- FTFP_BERT_TRV - uses G4EmStandardPhysicsGS
- G4PhysListFactory - added QGSP_BIC_AllHP (fixed problem #1732)

22-May-2015, Robert Hatcher             (phys-lists-V10-01-05)
- g4alt::G4PhysListFactory should now work with G4GenericPhysicsList
  on clang (3.4 and 3.5) and vc12
- cowork with tags "intercoms-V10-01-02", "emdna-V10-01-19",
  "emstand-V10-01-16", "hadr-cohe-V10-01-07", and "hadr-inclxx-V10-01-00"

22-May-2015, Robert Hatcher             (phys-lists-V10-01-04)
- Updates to g4alt::G4PhysListFactory to do more passthrough to underlying
  G4PhysListRegistry singleton.
- G4PhysListRegistry more checking that all the requested phys ctor
  additions are available; update output to closer match old factory
- Enable registration of ShieldingLEND, ShieldingM and G4GenericPhysicsList
  to g4alt::G4PhysListFactory; the later need update to G4AnyMethod.hh
- cowork with tag "intercoms-V10-01-01"

21-Apr-2015, Alberto Ribon              (phys-lists-V10-01-03)
- FTFP_BERT_TRV : Reverting back, i.e. switching on again the
  low-mass diffraction dissociation in G4HadronHElasticPhysics

21-Apr-2015, Alberto Ribon              (phys-lists-V10-01-02)
- FTFP_BERT_TRV : Switch off (temporarily) the low-mass diffraction
  dissociation in G4HadronHElasticPhysics

17-Feb-2015, Davide Mancusi             (phys-lists-V10-01-01)
- INCLXXPhysicsListHelper: do not use G4NeutronTrackingCut for *_HP physics
  lists

08-Jan-2015, Alberto Ribon              (phys-lists-V10-01-00)
- FTFP_BERT_TRV : Switch on low-mass diffraction dissociation
  in G4HadronHElasticPhysics

07-Nov-2014, Robert Hatcher             (phys-lists-V10-00-14)
- Also remove support for G4GenericPhysicsList in new factory
  until the problem w/ mac/clang and G4AnyMethod is understood
- cowork with tag "phys-ctor-fact-V10-00-02"

07-Nov-2014, Robert Hatcher             (phys-lists-V10-00-13)
- Remove support for ShieldingLEND & ShieldingM in new factory
  until the problem w/ mac/clang & linux/icc is understood
- cowork with tag "phys-ctor-fact-V10-00-02"

07-Nov-2014, P. Arce          (phys-lists-V10-00-12)
- Add QGSP_BIC_AllHP particle_hp physics list

07-Nov-2014, Gabriele Cosmo             (phys-lists-V10-00-11)
- Retagged.

05-Nov-2014, Robert Hatcher             (phys-lists-V10-00-10)
- Fixed overload ambiguity complaint from Visual Studio 12,
  and tag at the right level
- cowork with tag "phys-ctor-fact-V10-00-01" and "intercoms-V10-00-15"

04-Nov-2014, Robert Hatcher             (phys-lists-V10-00-09)
- Add g4alt::G4PhysListFactory as user extensible list factory;
   work done via G4PhysListRegistry and G4PhysListStamper classes.
- Modify LBE list ctor to accept ver(bosity) as optional arg
   in the same manner as other physics lists.
- cowork with tag "phys-ctor-fact-V10-00-01"

15-Oct-2014, Alex Howard           (phys-lists-V10-00-08)
- Increased cuts in LBE physics list to 1 micrometer (from 1 nanometer).

15-Oct-2014, Alex Howard           (phys-lists-V10-00-07)
- Bugfix 1591 for LBE
- removed Bertini Cascade from alphas, deuterons and tritons and replaced with
  BinaryLightIonReaction
- Replaced G4MuonMinusCaptureAtRest with G4MuonMinusCapture

05-Aug-2014, Krzysztof Genser           (phys-lists-V10-00-06)
- Extended Shielding code to also include ShieldingM variant

10-Jun-2014, V.Ivanchenko               (phys-lists-V10-00-05)
- INCLXXPhysicsListHelper - for the case of HP set cut on proton to
  zero to simulate all recoils from elastic scattering

06-Jun-2014, Alberto Ribon              (phys-lists-V10-00-04)
- Proposed the tag which includes the two internal tags below,
  made yesterday by Krzysztof and Vladimir I.

05-Jun-2014, V.Ivanchenko
- FTFP_BERT_HP, QGSP_BIC_HP, QGSP_BERT_HP - set cut on proton to
  zero to simulate all recoils from elastic scattering

05-Jun-2014, Krzysztof Genser
- Added ShieldingM and NuBeam to G4PhysListFactory

05-Jun-2014, Alberto Ribon              (phys-lists-V10-00-03)
- FTFP_BERT_TRV: use (temporary) G4HadronHElasticPhysics in order
  to allow testing of improvements in elastic.

03-June-2014, Julia Yarba               (phys-lists-V10-00-02)
- Include new (experimental) physics lists ShieldingM and NuBeam

03-Feb-2014, Luciano Pandola            (phys-lists-V10-00-01)
- Registered model in LBE.icc to handle neutron capture above 20 MeV
 (Bug Report 1562)

29-Jan-2014, Gunter Folger              (phys-lists-V10-00-00)
- Removed electromagnetic/dna, cascade/{evaporation,utils}, and
   isotope_productionfrom sources.cmake

07-Nov-2013, Tatsumi Koi                (phys-lists-V09-06-20)
-Activate production of fission fragments in Shielding PhysicsList

07-Nov-2013, Alberto Ribon              (phys-lists-V09-06-19)
- Removed low_energy and high_energy from sources.cmake and GNUmakefile.

04-Nov-2013, Tatsumi Koi                (phys-lists-V09-06-18)
-Set proton cut value to 0 for producing low energy recoil nucleus
-Use G4IonElasticPhysics for Elastic Scattering of GenericIon

30-Oct-2013, Alberto Ribon              (phys-lists-V09-06-17)
- LBE : deleted stoppingPhysics in the destructor (Coverity defect).

15-Oct-2013, Davide Mancusi             (phys-lists-V09-06-16)
- Missing header.

15-Oct-2013, Davide Mancusi             (phys-lists-V09-06-15)
- Make the *_HP variants of the INCLXX-based physics list use ElasticHP.

06-Sep-2013, Luciano Pandola            (phys-lists-V09-06-14)
- LBE.icc, add missing #include of G4HadronCaptureProcess
(gave compilation error to user application using LBE)

21-Aug-2013, Vladimir Ivantchenko       (phys-lists-V09-06-13)
- LBE - removed forgotten header

19-Aug-2013, Vladimir Ivantchenko       (phys-lists-V09-06-12)
- LBE - use G4UrbanMscModel instead on Urban93

14-Jun-2013, Peter Gumplinger           (phys-lists-V09-06-11)
- fix coverity error in LBE.inc

27-Mar-2013, Andrea Dotti		(phys-lists-V09-06-10)
- Adding mechanism for splitting class of base class G4VUserPhysicsList
  for LBE physics list (needed for G4MT).
  Co-working with tag in run category

28-Mar-2013, Alberto Ribon              (phys-lists-V09-06-09)
- LBE physics list: replaced LEP/HEP with FTFP+BERT.

20-Mar-2013, Vladimir Ivantchenko       (phys-lists-V09-06-08)
- PhysListFactory - fixed typo in previous tag

18-Mar-2013, Vladimir Ivantchenko       (phys-lists-V09-06-07)
- PhysListFactory - fixed bug report #1458 (correct printout of
    available Physics Lists); clean up of the code

04-Mar-2013, Davide Mancusi             (phys-lists-V09-06-06)
04-Mar-2013, Davide Mancusi             (phys-lists-V09-06-05)
04-Mar-2013, Davide Mancusi             (phys-lists-V09-06-04)
04-Mar-2013, Davide Mancusi             (phys-lists-V09-06-03)
- Added new INCL++-based physics lists:
  o QGSP_INCLXX_HP
  o FTFP_INCLXX
  o FTFP_INCLXX_HP
  These are based on the new INCLXXPhysicsListHelper class, which avoids
  unnecessary code duplication.
- Depends on tag phys-ctor-hinelastic-V09-06-05.
- Provides QGSP_INCLXX.hh and similar headers for backwards compatibility.

30-Jan-2013, Gunter Folger              (phys-lists-V09-06-02)
- fix sources.cmake for moved files

29-Jan-2013, Gunter Folger              (phys-lists-V09-06-01)
- move G4PhysListFactory from constructor/factory to lists.

10-Jan-2013, Gunter Folger              (phys-lists-V09-06-00)
- new directory structure introduced.
   lists directory only keeps physics lists, hadronic constructors moved to
   constructors/hadron_inelastic
